<?php
/**
* @author Mikko Rönkkö
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $_PLUGINS;
$_PLUGINS->registerFunction('onAfterUserProfileEditDisplay','getJS','extendedselect');
$_PLUGINS->registerFunction('onAfterRegisterUserDisplay','getJS','extendedselect');
$_PLUGINS->registerFunction('onBeforeUserUpdate','processNewFields','extendedselect');
$_PLUGINS->registerFunction('onBeforeUserRegistration','processNewFields','extendedselect');
$_PLUGINS->registerFunction('onBeforeNewUser','processNewFields','extendedselect');
$_PLUGINS->registerFunction('onAfterUserUpdate','cleanUp','extendedselect');
$_PLUGINS->registerFunction('onAfterUserRegistration','cleanUp','extendedselect');
$_PLUGINS->registerFunction('onAfterNewUser','cleanUp','extendedselect');

DEFINE ('_UE_REG_ADMIN_AF_SUB','ACTION REQUIRED! New Field Value Pending Approval');
DEFINE ('_UE_REG_ADMIN_AF_MSG','A new field has been created to [SITEURL] and requires approval.\n'
.'This email contains the details:\n\n'
.'Field Name - [NAME]\n'
.'Field Value - [VALUE]\n'
.'Please do not respond to this message as it is automatically generated and is for information purposes only\n');

class extendedselect extends cbPluginHandler{

	function getJS() {

		$this->_getLanguageFile();
		
		echo "<script src=\"components/com_comprofiler/plugin/user/plug_extendedselect/funcs.js\"></script>";

		$selects =  explode("|*|", $this->params->get('fields',''));
		
		echo "\n<script type=\"text/javascript\">";
		foreach($selects as $select){
			echo("\nenableExtendedSelect('".$select."[]','".
				getLangDefinition('_UE_OTHER_ENTRY')."','".
				getLangDefinition('_UE_INSERT_ENTRY')."');");
		}	
		echo "\n</script>";
	}
	function _getLanguageFile() {
		global $mainframe,$mosConfig_lang;
		$UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/user/plug_extendedselect';
		if (file_exists($UElanguagePath.'/language/'.$mosConfig_lang.'.php')) {
		  include_once($UElanguagePath.'/language/'.$mosConfig_lang.'.php');
		} else include_once($UElanguagePath.'/language/english.php');	
	}


/*
Checks if there are new values for selects. If such are found, they are inserted as values and in the moderation table
*/
	function processNewFields(&$row,&$rowExtras){
		
		global $database, $mosConfig_debug;
		$sql="select f.name, f.fieldid, v.fieldtitle as value from #__comprofiler_fields f, #__comprofiler_field_values v ".
			"where f.fieldid=v.fieldid and f.name IN (\"".str_replace('|*|','","',$this->params->get('fields',''))."\")";

		$database->setQuery($sql);
			
		$fieldValues=$database->loadObjectList();

		$fieldData =array();
		$fieldIDs= array();
		foreach($fieldValues as $fieldValue){
			if(!array_key_exists($fieldValue->name,$fieldData)){
				$fieldData[$fieldValue->name]=array();
				$fieldIDs[$fieldValue->name]=$fieldValue->fieldid;			
			}
			array_push($fieldData[$fieldValue->name],$fieldValue->value);
		}

		foreach($_POST as $nameP=>$valueP){
			foreach($fieldData as $nameF=>$valueArray){
				if($mosConfig_debug) echo ("<br>Comparing:".$nameP." to ".$nameF);
				$a=strpos($nameP,$nameF);
				if($a>=0&&$a==strlen($nameP)-strlen($nameF)){

					$this->_check($nameF,$valueP,$fieldIDs[$nameF],$valueArray,$rowExtras);
				}
			}
		}

		
	}

	function _check($name,$value,$fieldID,$valueArray,$rowExtras){
		global $mosConfig_debug, $database,$ueConfig,$mosConfig_livesite;
		
		if($mosConfig_debug) echo ("<br>PRE Checking value:".$value);

		if(is_array($value)){
			foreach($value as $val)
				$this->_check($name,$val,$fieldID,$valueArray,$rowExtras);	
		}
		else{	
			if(strpos($value,'|*|')!==false||$value=='other'||$value=='N/A'){
				$value='';
			}
		
			if($value!=''){
			
				if($mosConfig_debug) echo ("<br>Checking value:".$value);
	
				if(!in_array($value,$valueArray)){

/*
This section temporarily inserts the values to the real values. This is a workaround to cheat the securityhardenings of CB 1.0.2

We will later remove the new entries if moderation is on.
*/ 
					$sql="insert into #__comprofiler_field_values (fieldid,fieldtitle,ordering)".
					" values (".$fieldID.",'".$value."',999)";
					$database->setQuery($sql);
					$database->query();						
					
					if($this->params->get('moderation','0')==1){
						$database->setQuery($sql);
						$database->query();				

						$sql="insert into #__comprofiler_field_value_moderation (fieldid,value,conditionid)".
						" values (".$fieldID.",'".$value."',".$this->_getConditionID($fieldID,$value,$rowExtras).")";
						$database->setQuery($sql);
						$database->query();				


				//Notify administrator by email
						$cbNotification = new cbNotification();
						if($ueConfig['moderatorEmail']==1) {

							$cbNotification->sendToModerators(_UE_REG_ADMIN_AF_SUB,str_replace("[NAME]", $name,
								str_replace("[VALUE]", $value,
								str_replace("[SITEURL]", $mosConfig_livesite,_UE_REG_ADMIN_AF_MSG))));
						}
					}
				}
			}	
		}
	}

//Determines whether or not to autoassign condition to new entry

   function _getConditionID($fieldid,$value,&$rowExtras){
			global $database;

			//Check if there are conditions associated with this select
			
			$sql="select c.fieldname as `name`, c.value as `value`, c.id as `id` from #__comprofiler_fields f, #__comprofiler_conditions c where f.fieldid=".$fieldid
				." and f.name = c.fieldname limit 1";
				
			$database->setQuery($sql);
			
			$result=$database->loadRow();
			
			if($result==null) return 'null';
			
			//Check if a possible match for condition exists

			if($rowExtras[$result->name]==$result->value)
				return $result->id;
			
			//Not found, creating new
			$sql="insert into #__comprofiler_conditions (fieldname,value) values('"
				.$result->name."','".$rowExtras[$result->name]."')";
				
			$database->query($sql);
		   
		   return $database->insertid;
   
   }
   

	function loadSelectList($name,$value,$control_name) {
	
	global $database;

	$database->setQuery("select name, title from #__comprofiler_fields where type='select' or type ='multiselect'");
	$selects = $database->loadObjectList();
	$selectList = array();
	
	$selectList[] = mosHTML::makeOption(-1,'none');
	foreach ($selects as $select) {
			$postfix='';
			$selectList[] = mosHTML::makeOption( ($select->name).$postfix, $select->title);
	}
	$valAsObj = (isset($value)&&$value!='') ?
	array_map(create_function('$v', '$o=new stdClass(); $o->value=$v; return $o;'), explode("|*|", $value ))
	:null;

	return moscomprofilerHTML::selectList( $selectList, $control_name .'['. $name .'][]', 'size="4" multiple="multiple"', 'value', 'text', $valAsObj, true );	
		
	}
	function cleanUp(&$row,&$rowExtras){
		global $database;
		
		if($this->params->get('moderation','0')==1){
					$sql="delete from #__comprofiler_field_values where ordering = 999";
					$database->setQuery($sql);
					$database->query();			
		}	
	}

}

?>
